
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Bill_linesDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const bill_lines = await db.bill_lines.create(
            {
                id: data.id || undefined,
        
        description: data.description
        ||
        null
            ,
            
        amount: data.amount
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await bill_lines.setBill( data.bill || null, {
            transaction,
        });
        
        await bill_lines.setExpense_account( data.expense_account || null, {
            transaction,
        });
        
        await bill_lines.setCompanies( data.companies || null, {
            transaction,
        });
        

        

        

        return bill_lines;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const bill_linesData = data.map((item, index) => ({
                id: item.id || undefined,
                
                description: item.description
            ||
            null
            ,
            
                amount: item.amount
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const bill_lines = await db.bill_lines.bulkCreate(bill_linesData, { transaction });

        // For each item created, replace relation files
        

        return bill_lines;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const bill_lines = await db.bill_lines.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.amount !== undefined) updatePayload.amount = data.amount;
        
        
        updatePayload.updatedById = currentUser.id;

        await bill_lines.update(updatePayload, {transaction});

        
        
        if (data.bill !== undefined) {
            await bill_lines.setBill(
              
              data.bill,
              
              { transaction }
            );
        }
        
        if (data.expense_account !== undefined) {
            await bill_lines.setExpense_account(
              
              data.expense_account,
              
              { transaction }
            );
        }
        
        if (data.companies !== undefined) {
            await bill_lines.setCompanies(
              
              data.companies,
              
              { transaction }
            );
        }
        

        
        

        

        return bill_lines;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const bill_lines = await db.bill_lines.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of bill_lines) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of bill_lines) {
                await record.destroy({transaction});
            }
        });


        return bill_lines;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const bill_lines = await db.bill_lines.findByPk(id, options);

        await bill_lines.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await bill_lines.destroy({
            transaction
        });

        return bill_lines;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const bill_lines = await db.bill_lines.findOne(
            { where },
            { transaction },
        );

        if (!bill_lines) {
            return bill_lines;
        }

        const output = bill_lines.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.bill = await bill_lines.getBill({
            transaction
        });
        
        
        output.expense_account = await bill_lines.getExpense_account({
            transaction
        });
        
        
        output.companies = await bill_lines.getCompanies({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userCompanies = (user && user.companies?.id) || null;
        

        
        if (userCompanies) {
            if (options?.currentUser?.companiesId) {
                where.companiesId = options.currentUser.companiesId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.bills,
        as: 'bill',
        
        where: filter.bill ? {
          [Op.or]: [
            { id: { [Op.in]: filter.bill.split('|').map(term => Utils.uuid(term)) } },
            {
              bill_no: {
                [Op.or]: filter.bill.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.chart_of_accounts,
        as: 'expense_account',
        
        where: filter.expense_account ? {
          [Op.or]: [
            { id: { [Op.in]: filter.expense_account.split('|').map(term => Utils.uuid(term)) } },
            {
              account_name: {
                [Op.or]: filter.expense_account.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.companies,
        as: 'companies',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'bill_lines',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.amountRange) {
                const [start, end] = filter.amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    amount: {
                    ...where.amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      
      if (filter.companies) {
        const listItems = filter.companies.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          companiesId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.companiesId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.bill_lines.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'bill_lines',
                        'description',
                        query,
                    ),
                ],
            };
        }

        const records = await db.bill_lines.findAll({
            attributes: [ 'id', 'description' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['description', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.description,
        }));
    }

    
};

